
#if !defined(AFX_WCTITLE_H__382C63DF_23CB_44B5_A23C_4709AF26106B__INCLUDED_)
#define AFX_WCTITLE_H__382C63DF_23CB_44B5_A23C_4709AF26106B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

#include "stdafx.h"
#include "wctitle.h"
#include "iniFile.h"
#include <iostream>

#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include <winAble.h>
#include <Tlhelp32.h>

#include <windows.h>

// NT specific data types and enumerations
typedef LONG NTSTATUS;

typedef struct _tagPROCESS_BASIC_INFORMATION
{
    DWORD ExitStatus;
    DWORD PebBaseAddress;
    DWORD AffinityMask;
    DWORD BasePriority;
    ULONG UniqueProcessId;
    ULONG InheritedFromUniqueProcessId;
}   PROCESS_BASIC_INFORMATION;

typedef enum _tagPROCESSINFOCLASS 
{
    ProcessBasicInformation,
    ProcessQuotaLimits,
    ProcessIoCounters,
    ProcessVmCounters,
    ProcessTimes,
    ProcessBasePriority,
    ProcessRaisePriority,
    ProcessDebugPort,
    ProcessExceptionPort,
    ProcessAccessToken,
    ProcessLdtInformation,
    ProcessLdtSize,
    ProcessDefaultHardErrorMode,
    ProcessIoPortHandlers,          // Note: this is kernel mode only
    ProcessPooledUsageAndLimits,
    ProcessWorkingSetWatch,
    ProcessUserModeIOPL,
    ProcessEnableAlignmentFaultFixup,
    ProcessPriorityClass,
    MaxProcessInfoClass
}   PROCESSINFOCLASS;


// convenience macros
#define DYNLOADED_FPTR( ptrname, procname, dllname)\
FPTR_##procname ptrname = \
( FPTR_##procname ) GetProcAddress ( GetModuleHandle (  _TEXT( #dllname)), #procname);

#define CREATE_DYNFUNC_5( ptrname, procname, dllname, rettype, callconv, a1, a2, a3, a4, a5)\
typedef  rettype (callconv *FPTR_##procname) ( a1, a2, a3, a4, a5);\
DYNLOADED_FPTR( ptrname, procname, dllname);

class IniSettings {
public:
	//default location of wctitle.ini file
	static const CString m_inifilePath;
	
	//Tempate of the Windows Commander main title
	CString m_TitleTemplate;
	
	CString m_Version;
	CString m_RegName;
	CString m_WCPath;
	int m_Activeistances;

	IniSettings():m_Activeistances(0) {m_TitleTemplate="Windows Commander %s - %s";};
	IniSettings(char v[]):m_Activeistances(0) {m_TitleTemplate="Windows Commander %s - %s"; m_Version=v;};
	bool Init(char v[]="");
	~IniSettings() {m_inifile.WriteFile();};
	
	bool WriteIniFile();

private:
	CIniFile m_inifile;
};

class ProcessInfo {
public:
	DWORD m_ID;
	HANDLE m_Handle;
	HWND m_hWnd;
	CString m_Exe;

	ProcessInfo(): m_ID(0), m_Handle(NULL), m_bInitialized(false), m_hWnd(NULL) { }
	~ProcessInfo();
	bool Init();	

private:
	DWORD GetParentProcessID (DWORD dwPID);
	bool m_bInitialized;
};

//  Global Prototypes
BOOL gIsNT();
int Main(int argc, TCHAR* argv[], TCHAR* envp[]);
bool gInitialChecks(IniSettings *psets, int argc, TCHAR* argv[]);

#endif // !defined(AFX_WCTITLE_H__382C63DF_23CB_44B5_A23C_4709AF26106B__INCLUDED_)
